<?php

class ScratchProject {
	public static function registerTags( &$parser ) {
		$parser->setHook( 'scratchproject', [ __CLASS__, 'scratchproject' ] );
	}

	public static function scratchproject( $input, $argv, $parser ) {
		$sites = isset($argv["turbowarp"]) ? ["turbowarp.org","499","416"] : ["scratch.mit.edu/projects","485","402"];
		$param = isset($argv["turbowarp"]) && $argv["turbowarp"]!="" ? '?'.$argv["turbowarp"] : '';
		if (isset($argv["project-id"]) && preg_match('/^[0-9]+$/u',$argv["project-id"])) {
			return '<iframe src="https://'.$sites[0].'/'.$argv["project-id"].'/embed'.$param.'" allowtransparency="true" width="'.$sites[1].'" height="'.$sites[2].'" frameborder="0" scrolling="no" style="'.(isset($argv["style"]) ? $argv["style"] : '').'" allowfullscreen></iframe>';
		} else {
			$parser->addTrackingCategory( 'scratchproject-error-category' );
			return '<div class="mw-message-box-error mw-message-box"><b>ScratchProject ParserError</b>: Property "project-id" is undefined or invalid property value "project-id"</div>';
		}
	}
}